<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="xml" version="1.0" encoding="ISO-8859-1" omit-xml-declaration="no" indent="no" media-type="text/html"/>

<!-- An XSL template for munging HDF-EOS granule files to add stuff
	needed by ECHO

     	Revision History: Created 09/09/2004 bane

-->

<!-- The template below assumes external definition of these variables:

	httpROOT - http://machine
	dataPATH - data/path
	fileNAME - filename
	fileEXT  - .hdf or whatever
-->

<!-- Would you believe - this is a default template that just copies the
	current element and its attributes, and then tries templates on
	the rest of the content?  Simple, eh?  Bleah.
-->
<xsl:template match="*">
<xsl:element name="{name(.)}"><xsl:copy-of select="@*"/><xsl:apply-templates/></xsl:element>
</xsl:template>

<xsl:template match="DataCenterId">
  <DataCenterId>DUtestDCID</DataCenterId>
</xsl:template>

<xsl:template match="GranuleUR">
  <GranuleUR><xsl:value-of select="$fileNAME"/>.<xsl:value-of select="$fileEXT"/></GranuleUR>
</xsl:template>

<!-- This is where we patch in the URLs:
	direct link to dataset,
	OPeNDAP link,
        human-readable metadata
      -->
<xsl:template match="OnlineAccessURLs">
  <OnlineAccessURLs>
   <OnlineAccessURL>
    <URL><xsl:value-of select="$httpROOT"/>/<xsl:value-of select="$dataPATH"/>/<xsl:value-of select="$fileNAME"/>.<xsl:value-of select="$fileEXT"/></URL>
    <URLDescription>HDF-EOS dataset</URLDescription>
   </OnlineAccessURL>
   <OnlineAccessURL>
    <URL><xsl:value-of select="$httpROOT"/>/<xsl:value-of select="$dodsCALL"/>/<xsl:value-of select="$dataPATH"/>/<xsl:value-of select="$fileNAME"/>.<xsl:value-of select="$fileEXT"/></URL>
    <URLDescription>OPeNDAP link to dataset</URLDescription>
   </OnlineAccessURL>
   <OnlineAccessURL>
    <URL><xsl:value-of select="$httpROOT"/>/<xsl:value-of select="$fileNAME"/>.html</URL>
    <URLDescription>human-readable metadata</URLDescription>
   </OnlineAccessURL>
 </OnlineAccessURLs>
</xsl:template>

<xsl:template match="InsertTime">
  <InsertTime>2000-01-01</InsertTime>
</xsl:template>

<xsl:template match="LastUpdate">
  <LastUpdate>2000-01-01</LastUpdate>
</xsl:template>

<xsl:template match="X">
  <X>DUtestDCID</X>
</xsl:template>

</xsl:stylesheet>