<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="xml" version="1.0" encoding="ISO-8859-1" omit-xml-declaration="no" indent="no" media-type="text/html"/>

<!-- An XSL template for grabbing field information out of
	HDF-EOS XML Swath and Grid files

     	Revision History: Created 04/22/2004 bane

-->

<!-- The template below assumes external definition of these variables:

	httpROOT - http://machine
	dataPATH - data/path
	dodsCALL - cgi-bin/dods-handler
	fileNAME - filename
	fileEXT  - extension
        fileENDIAN - "big" or "little"
-->

<xsl:variable name="dodsPATH"><xsl:value-of select="$httpROOT"/>/<xsl:value-of select="$dodsCALL"/>/<xsl:value-of select="$dataPATH"/>/<xsl:value-of select="$fileNAME"/>.<xsl:value-of select="$fileEXT"/></xsl:variable>

<xsl:variable name="rawPATH"><xsl:value-of select="$httpROOT"/>/<xsl:value-of select="$dataPATH"/>/<xsl:value-of select="$fileNAME"/>.<xsl:value-of select="$fileEXT"/></xsl:variable>

<xsl:variable name="fieldsPATH"><xsl:value-of select="$httpROOT"/>/<xsl:value-of select="$dataPATH"/>/<xsl:value-of select="$fileNAME"/></xsl:variable>

<xsl:template match="/">


<OpenDAPLinks>
   <WholeFile dods="{$dodsPATH}" raw="{$rawPATH}"/>
<FieldLinks>
<ByteOrder order="{$fileENDIAN}"/>
<xsl:for-each select="/HDFEOS-File/HDFEOS/SWATHS/Swath/GeoFields">
<GeoFields>
<xsl:for-each select="./GeoField">
    <xsl:variable name="crapPATH"><xsl:value-of select="link_to_data"/></xsl:variable>
    <xsl:variable name="dataTYPE">
	<xsl:choose>
	  <xsl:when test="DataType/IntegerType">Integer (<xsl:value-of select="DataType/IntegerType/@Size"/>)</xsl:when>
	  <xsl:when test="DataType/FloatType">Floating-point (<xsl:value-of select="DataType/FloatType/@Size"/>)</xsl:when>
	  <xsl:otherwise>Unknown</xsl:otherwise>
	</xsl:choose>
    </xsl:variable>
   <GeoField
	name="{@Name}" 
	type="{$dataTYPE}"
	dodslink="{$dodsPATH}.dods?{@Name}"
      	datalink="{$fieldsPATH}/{substring-after(string($crapPATH), 'file:./')}"/>
</xsl:for-each>

</GeoFields>
</xsl:for-each>

<DataFields>
<xsl:for-each select="/HDFEOS-File/HDFEOS/SWATHS/Swath/DataFields/DataField">
    <xsl:variable name="crapPATH"><xsl:value-of select="link_to_data"/></xsl:variable>
    <xsl:variable name="dataTYPE">
	<xsl:choose>
	  <xsl:when test="DataType/IntegerType">Integer (<xsl:value-of select="DataType/IntegerType/@Size"/>)</xsl:when>
	  <xsl:when test="DataType/FloatType">Floating-point (<xsl:value-of select="DataType/FloatType/@Size"/>)</xsl:when>
	  <xsl:otherwise>Unknown</xsl:otherwise>
	</xsl:choose>
    </xsl:variable>
   <DataField name="{@Name}" type="{$dataTYPE}" dodslink="{$dodsPATH}.dods?{@Name}"
      	datalink="{$fieldsPATH}/{substring-after(string($crapPATH), 'file:./')}"/>
</xsl:for-each>

<xsl:for-each select="/HDFEOS-File/HDFEOS/GRIDS/Grid/GridDataField">
    <xsl:variable name="crapPATH"><xsl:value-of select="link_to_data"/></xsl:variable>
    <xsl:variable name="dataTYPE">
	<xsl:choose>
	  <xsl:when test="DataType/IntegerType">Integer (<xsl:value-of select="DataType/IntegerType/@Size"/>)</xsl:when>
	  <xsl:when test="DataType/FloatType">Floating-point (<xsl:value-of select="DataType/FloatType/@Size"/>)</xsl:when>
	  <xsl:otherwise>Unknown</xsl:otherwise>
	</xsl:choose>
    </xsl:variable>
   <DataField name="{@Name}" type="{$dataTYPE}" dodslink="{$dodsPATH}.dods?{@Name}"
      	datalink="{$fieldsPATH}/{substring-after(string($crapPATH), 'file:./')}"/>
</xsl:for-each>
</DataFields>

</FieldLinks>
</OpenDAPLinks>
</xsl:template>

</xsl:stylesheet>